#include <FastLED.h>

CRGB leds[150];
const byte maxChars = 150;
char receivedChars[maxChars];

int numLEDs[6] = {6, 8, 150, 150, 150, 150};    //numberLEDs
byte arrayAnimation[5] = {0, 0, 0, 0, 0}; //What animation to play on strips
byte ledPosition[5] = {0, 0, 0, 0, 0};      //Custom Color number(which number to display when using custom colors)
//h    h2    h3    checkValue
byte ledColor[5][4] = {{255, 255, 255, 0}, {255, 255, 255, 0},
  {255, 255, 255, 0}, {255, 255, 255, 0}, {255, 255, 255, 0}
};         //What H value to play on each strip

byte Position = 0; //RunningRainbows
byte SlowPosition = 0;
byte SlowIncrement = 0;

unsigned long timeNow = 0;
unsigned long timeNow2 = 0;

//unsigned long startTime = 0;
//unsigned long timeElapsed = 0;

byte cycle = 0; //for police

byte h = 0;
byte h2 = 0;
byte h3 = 0;
byte s = 0;

byte NUM_LEDS = 100;

char *ptr = NULL;
char *strings[25];
//float colors[20];
byte index = 0;
bool hasChanged = false; //switching colors

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  //  Serial.println("Begin!");
  FastLED.addLeds<WS2812B, 2, GRB>(leds, 150); //0
  FastLED.addLeds<WS2812B, 3, GRB>(leds, 150); //1
  FastLED.addLeds<WS2812B, 4, GRB>(leds, 150); //2
  FastLED.addLeds<WS2812B, 5, GRB>(leds, 150); //3
  FastLED.addLeds<WS2812B, 6, GRB>(leds, 150); //4
}

void loop() {
  recieveText();
}
void loopAnimations() {
  for (byte i = 0; i < 5; i++) { //led count
    if (arrayAnimation[i] > 0 && arrayAnimation[i] < 90) {
      clearLEDS(NUM_LEDS);
      NUM_LEDS = numLEDs[i];
      playAnimation(arrayAnimation[i]);
      FastLED[i].showLeds();
    }
  }

  if (millis() > timeNow + 100) {
    if (Position > 255) {
      Position = 0;
    }
    Position++;

    timeNow = millis();
  }
  if (millis() > timeNow2 + 100) {
    timeNow2 = millis();
    SlowPosition++;
    SlowIncrement += 2;
    if (SlowIncrement > 255) {
      SlowIncrement = 0;
    }
    hasChanged = false;
  }
}
void playAnimation(byte x) {
  //x = which animation to play
  //led strip is which strip to play on(to know LED size)
    switch (x) {
      case 2:
        GradualRainbow();
        break;
      case 3:
        MoveRainbow();
        break;
      case 4:
        RunningRainbow();
        break;
      case 5:
        SlowRainbow();
        break;
      case 11:
        Erase(x);
        break;
      case 12:
        Juggle();
        break;
      case 13:
        Party();
        break;
      case 14:
        Police();
        break;
      case 16:
        RandomFlash(x);
        break;
      case 15:
        RandomFade(x);
        break;
      case 17:
        //      RandomWipe(x);
        break;
         case 51:
        Flash(x);
        break;
      default:
        break;
    }
}
void playOnce(byte x) {
  switch (x) {
    case 95:
      USA();
      break;
    case 96:
      fill_rainbow( leds, NUM_LEDS, 0, 7);
      break;
    case 97:
      fill_gradient (leds, NUM_LEDS, CHSV(h, 255, 255), CHSV(h2, 255, 255), SHORTEST_HUES);
      break;
    case 98:
      fill_gradient (leds, NUM_LEDS, CHSV(h, 255, 255), CHSV(h2, 255, 255), CHSV(h2, 255, 255), SHORTEST_HUES);
      break;
    case 99:
      fill_solid( leds, NUM_LEDS, CRGB( 0, 0, 0) );
      break;
    default:
      break;
  }
}

void recieveText() {
  static byte letter = 0;
  byte type = 0;
  byte channel = 0;
  char endMarker = '\n';
  char rc;

  if (Serial.available()) {
    rc = Serial.read(); //rc = each individual character
    if (rc != endMarker) {
      receivedChars[letter] = rc; //all letters get put into an array
      letter++;
      if (letter >= maxChars) {
        letter = maxChars - 1;
      }
    } else {
      receivedChars[letter] = '\0'; // terminate the string
      Serial.print(receivedChars);
      letter = 0;
      repeatSteps(true);
      //channel ledCount type h s
      channel = atoi(strings[0]);
      channel + 1;
      NUM_LEDS = atoi(strings[1]);
      type = atoi(strings[2]);
      //      colorSpeed = atoi(strings[3]);
      numLEDs[channel] = NUM_LEDS;    //numberLEDs
      arrayAnimation[channel] = type;        //What animation to play on strips
      if (channel == 5) {
        arrayAnimation[0] = type;
        arrayAnimation[1] = type;
        arrayAnimation[2] = type;
        arrayAnimation[3] = type;
        arrayAnimation[4] = type;
      }
      if (type == 0) {
        h = strtod(strings[3], NULL);
        s = atof(strings[4]);
        if (strings[4] == "") {
          s = 255;
        }
        for (byte i = 0; i < NUM_LEDS; i++) {
          leds[i].setHSV( h, s, 255);
        }
        index = 0;
      }
      //customized animations
      if (type > 50 && type < 90) {
        ledColor[channel][0] = strtod(strings[3], NULL);
        ledColor[channel][1] = strtod(strings[4], NULL);
        ledColor[channel][2] = strtod(strings[5], NULL);
      }
      
      //play once animations - gradients/usa/rainbow
      if (type >= 90) {
        if (type >= 97) {
          h = strtod(strings[3], NULL);
          h2 = strtod(strings[4], NULL);
        }
        if (type == 98) {
          h3 = strtod(strings[5], NULL);
        }
        playOnce(type);
        arrayAnimation[channel] = 0; //reset to 0 so it doest keep looping animation function
      }
      
      if (channel < 5) {
        FastLED[channel].showLeds();
      } else {
        arrayAnimation[0] = type;
        arrayAnimation[1] = type;
        arrayAnimation[2] = type;
        arrayAnimation[3] = type;
        arrayAnimation[4] = type;
        FastLED.show();
      }
      //Reset LEDS-----
      memset(receivedChars, 0, sizeof(receivedChars));
      memset(strings, 0, sizeof(strings));
      //---------------
    }
  } else {
    loopAnimations();
  }
}
void repeatSteps(bool firstTime) {
  ptr = NULL;
  if (firstTime) {                    //strips all of the info taken - type, led num, colors,
    ptr = strtok(receivedChars, ";");
    while (ptr != NULL)
    {
      strings[index] = ptr;
      index++;
      ptr = strtok(NULL, ";");
    }
  }
  index = 0;
}

void Flash(byte x){
  if(SlowPosition % 8 == 0 && SlowPosition != ledPosition[3]){
    if(ledPosition[x] < 3){
    ledPosition[x]++;
    ledPosition[3] = SlowPosition;
    }else{
      ledPosition[x] = 0;
    }
  }
  fill_solid(leds, NUM_LEDS, CHSV(ledColor[x][ledPosition[x]], 255, 255));
}














void Erase(byte x) {
  // running red stripes
  for (uint16_t i = 0; i < NUM_LEDS; i++) {
    uint8_t fade = (millis() / 6) + (i * 8);
    if (fade % 256 == 0 && i == 0) {
      ledColor[x][0] = random8();
      fade = 0;
    }
    leds[i] = CHSV(ledColor[x][0], 255, fade);
  }
}
void RandomFade(byte x) {
  byte fade = 0;
  if (SlowIncrement < 64 || (SlowIncrement > 126 && SlowIncrement < 192)) {
    fade = SlowIncrement * 4;
  }
  if ((SlowIncrement >= 64 && SlowIncrement < 126) || SlowIncrement >= 192) {
    fade = 256 - abs(252 - SlowIncrement * 4);
  }
  for (byte i = 0; i < 6; i++) {
    if (SlowIncrement == 0) {
      ledColor[x][0] = random8();
    }
    leds[i] = CHSV(ledColor[x][0], 255, fade);
  }
}

void RandomFlash(byte x) {
  if (SlowIncrement % 64 == 0 && !hasChanged) {
    ledColor[x][0] = random8();
    hasChanged = true;
  }
  for (byte i = 0; i < 6; i++) {
    leds[i] = CHSV(ledColor[x][0], 255, 255);
  }
}



void Juggle() {
  fadeToBlackBy( leds, NUM_LEDS, 20);
  byte dothue = 0;
  for ( byte i = 0; i < NUM_LEDS / 6; i++) {
    leds[beatsin16( i + 7, 0, NUM_LEDS - 1 )] |= CHSV(dothue, 150 + random8(25), 200 + random8(50));
    dothue += 32;
  }
}

void RunningRainbow() {
  for (byte i = 0; i < NUM_LEDS; i++) {
    leds[i].setHSV(Position, 255, qadd8(((sin(i + Position) * 127 + 128)), 10));
  }
}
void Party() {
  // the moving rainbow
  for (uint16_t i = 0; i < NUM_LEDS; i++) {
    leds[i] = CHSV((millis() / 4) - (i * 3), 255, 255);
  }
}
//
//Back and fourth
void MoveRainbow() {
  uint8_t beatA = beatsin8(17, 0, 255);
  uint8_t beatB = beatsin8(13, 0, 255);
  fill_rainbow(leds, NUM_LEDS, (beatA + beatB) / 2, 6);
}
//Stretched Out rainbow going forward
void SlowRainbow() {
  uint8_t beatA = beatsin8(7, 0, 255);                        // Starting hue
  fill_rainbow(leds, NUM_LEDS, beatA, 2); //2 = longer gradient strip
}
//Long then short rainbow
void GradualRainbow() {
  uint8_t starthue = beatsin8(5, 0, 255);
  uint8_t endhue = beatsin8(7, 0, 255);
  if (starthue < endhue) {
    fill_gradient(leds, NUM_LEDS, CHSV(starthue, 255, 255), CHSV(endhue, 255, 255), FORWARD_HUES); // If we don't have this, the colour fill will flip around.
  } else {
    fill_gradient(leds, NUM_LEDS, CHSV(starthue, 255, 255), CHSV(endhue, 255, 255), BACKWARD_HUES);
  }
}
//void RandomWipe(byte x) {
//    NUM_LEDS = numLEDs[0];
//    h = ledColor[0];
//  if (Position < NUM_LEDS + 1 && Position != 0) {
//    for (byte i = 0; i < Position; i++) {
//      leds[i].setHSV(h, 255, 255);
//    }
//  } else {
//    ledColor[x] = random(255);
//    Position = 1;
//  }
//}
//void RandomWipe(byte x) {
//  //  NUM_LEDS = numLEDs[x];
//  if (SlowPosition < NUM_LEDS + 1 && SlowPosition != 0) {
//    for (byte i = 0; i < SlowPosition; i++) {
//      leds[i].setHSV(h, 255, 255);
//    }
//    Position = SlowPosition;
//  } else {
//    h = random(255);
//    Position = 1;
//    SlowPosition = 1;
//  }
//}
//
//void RandomFlash() {
//  if(SlowIncrement % 10 == 0){
//  fill_solid(leds, 150, CHSV(random(255), 255, 255));
//  }
//}
//
void Police() {

  if (SlowPosition < 8) {
    if (SlowPosition % 2 == 0 ) {
      for (byte i = 0; i < NUM_LEDS; i++) {
        if (i < NUM_LEDS / 2) {
          leds[i].setRGB(255, 0, 0);
        } else {
          leds[i].setRGB(0, 0, 255);
        }
      }
    } else {
      for (byte i = 0; i < NUM_LEDS; i++) {
        if (i < NUM_LEDS / 2) {
          leds[i].setRGB(0, 0, 255);
        } else {
          leds[i].setRGB(255, 0, 0);
        }
      }
    }
  }
  if (SlowPosition < 16) {
    for (byte i = 0; i < NUM_LEDS; i++) {
      if (SlowPosition % 2 == 0) {
        leds[i].setRGB(255, 0, 0);
      } else {
        leds[i].setRGB(0, 0, 255);
      }
    }
  }
  if (SlowPosition > 16) {
    SlowPosition = 0;
  }
}
void USA() {
  byte cycle = 0;
  for (byte i = 0; i < NUM_LEDS; i++) {
    if (cycle < NUM_LEDS / 6 || (cycle >= (NUM_LEDS / 6) * 3 && cycle < (NUM_LEDS / 6) * 4)) {
      leds[i].setHSV(1, 255, 255);
    }
    if ((cycle >= NUM_LEDS / 6 && cycle < (NUM_LEDS / 6) * 2) || (cycle >= (NUM_LEDS / 6) * 4 && cycle < (NUM_LEDS / 6) * 5)) {
      leds[i].setHSV(165, 255, 255);
    }
    if ((cycle >= (NUM_LEDS / 6) * 2 && cycle < (NUM_LEDS / 6) * 3) || (cycle >= (NUM_LEDS / 6) * 5)) {
      leds[i].setHSV(0, 0, 255);
    }
    if (cycle < NUM_LEDS) {
      cycle++;
    }
  }
}
void clearLEDS(byte strip) {
  //  fill_solid( &(leds[i]), NUM_LEDS, CRGB( 0, 0, 0) );
  fill_solid( leds, NUM_LEDS, CRGB( 0, 0, 0) );

}
